#!/usr/bin/perl 
# Lanlord(tm) is a program written by David Stokes (David@uhw.com) of UHW
# Corporation, Carrollton Texas, and is distributed via the GNU Public
# license (GPL).  No warrantee expressed or implied.  If you make changes
# to this program, notify the author and be ready to explain what you did
# as he can be a bit dense. Lanlord is tradeamrked by David Stokes.
#
use	CGI qw(:standard);
#
# Variables that CHANGE with your systems' configuration
#
$LEASE = "/etc/dhcpd.leases";
$TEMP = "/tmp/dhcp";

# Variables for this program
$prog="Lanlord";
$ver="0.1";
#
# Variables for pretty printing the date
#
@week = ("Sun","Mon","Tue","Wed","Thu","Fri","Sat");
$thisday = (Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday) [(localtime)[6]]; $thismon = (January,February,March,April,May,June,July,August,September,October,
November,December) [(localtime)[4]];
$ndthday = ('1st','2nd','3rd','4th','5th','6th','7th','8th','9th','10th','11th',
'12th','13th','14th','15th','16th','17th','18th','19th','20th','21st','22nd','23
rd','24th','25th','26th','27th','28th','29th','30th','31st') [(localtime)[3] - 1
];
($mysec,$mymin,$myhour,$myday,$mymon,$myyear,$mywday,$myydat,$mydst) = localtime();


#
# Program logic starts here
#
$|=1;
$count=1;
print header,start_html(-title=>'DHCP Leases',	
			-style=>{'src'=>"/lanlord/lanlord.css"},-dtd=>1);
print h2("DHCP Leases for $myhour:$mymin:$mysec $thisday, $thismon $ndthday");
print h5("Lease File: $LEASE");

open (L, "< $LEASE") || die("No lease file ($LEASE) found");
open (T, "> $TEMP") || die("No temp file ($TEMP) found");
while ($line=<L>) {   #  We have a line for a lease
		$parse=$line;
	if (($line =~ s/lease/ /)) {    # Do we have a lease entry
		($foo,$lip,$foo2) = split(/ /,$parse);
		print T "$lip";
		$count++;
	($foo,$lsdow,$lsdate,$lstime)=split(/ /,<L>);
		$lstime =~ s/;//g;
		$lstime =~ s/\n//g;
		print T ",$lsdow,$lsdate,$lstime";
	($foo,$ledow,$ledate,$letime)=split(/ /,<L>);
		$letime =~ s/\n//g;
		$letime =~ s/;//g;
		print T ",$ledow,$ledate,$letime";
	($third,$foo,$mac) = split(/ /,<L>);  # is lease abandoned?
		$third =~ s/;//g;
		$third =~ s/\t//g;
		$three = $third;
		if (($third =~ s/aban/ /)) {
			print T ",abandoned";
		} else {
			$gosix=1;
			$mac =~ s/;//g;
			$mac =~ s/\n//g;
			print T ",$mac";
		}
	if ($gosix) {  # have six lines of data, not abandoned
		$foo=<L>;  #do nothing with UID lines
		$gosix=0;
	}
	$lhost = <L>;
	$lhost =~ s/client-hostname "//g;
	$lhost =~ s/^[ ]*//g;
	$lhost =~ s/\"//g;
	$lhost =~ s/;//g;
	$lhost =~ s/\n//g;
	$lhost =~ s/\t//g;
	print T ",$lhost\n";
	}
}
close (T);
open (T, "< $TEMP") || die("No temp file ($TEMP) found");
#
#  Read the leases file, put entrys into a hash
#
%lease = ();
while ($line=<T>) {
($ip,$sdow,$sdate,$shour,$edow,$edate,$ehour,$status,$host) = split(/,/,$line);
	$host =~ s/\n//g;
	$lease{"$ip"} = $line;
}
print	"<TABLE border=\"1\">";
print	"<CAPTION>DHCP Leases</CAPTION>";
print	"<TH >IP address</TH>";
print	"<TH >Host Name</TH>";
print	"<TH >Lease Start</TH>";
print	"<TH >Lease End</TH>";
print	"<TH >MAC/last host</TH>";
#
# Sort the hash keys to make them more readable.
#
@keys = sort (keys %lease) ;
foreach $key (@keys) {
	$value = $lease{$key};
($ip,$sdow,$sdate,$shour,$edow,$edate,$ehour,$status,$host) = split(/,/,$value);
	if ($status eq "abandoned") {
  	  $status = $host;
	  print "<TR><td >$ip</td><td ><em>abandoned</i></td>";	
	} else {
	  print "<TR><td >$ip</td><td >$host</td>";	
	}
	$whatday = $week[$sdow];
	print "<td >$whatday $shour $sdate</td>";
	$whatday = $week[$edow];
	print "<td >$whatday $ehour $edate</td>";
	print "<td >$status</td></tr>\n";
}
#
# Clean up
#
print	"</TABLE><p>";
print	a({href => "/cgi-bin/lanlord.cgi"},"Update Report");
print	p,a({href => "http://linux.uhw.com/software/lanlord/index.html"},"<font size=\"1\">Made with $prog<sup>TM</SUP> ($ver)</font>");
close (T);
close (L);
print end_html;
exit(0);
